/*normal vektorens elementer divideret med lngden af vektoren skulle meget gerne give en
enhedsvektor der er ortagonal p retningen, derfor skal jeg */

void clean_trail(global *g_point, trail_header* header)
	{
	int i=0;

		while(i<g_point->trail_length)
		{
		header->trail[i].intensity=0;

		header->trail[i].middle_v.X=0;
		header->trail[i].middle_v.Y=0;

		header->trail[i].left_v.X=0;
		header->trail[i].left_v.Y=0;

		header->trail[i].right_v.X=0;
		header->trail[i].right_v.Y=0;

		i++;
		}
	header->newest=0;
	}

trail_header* create_trail(global * g_point)
	{
	trail_header* header=malloc(sizeof(trail_header)+(sizeof(trail_element)*g_point->trail_length));

	header->trail=(trail_element *)header+(sizeof(trail_header));

	clean_trail(g_point, header);

return header;
}



void update_trail(global *g_point, trail_header *current, player *orign)
	{
	float X, Y;

	current->newest++;

	if (current->newest>=g_point->trail_length)
		current->newest=0;

	int newest=current->newest;

	if (current->newest>=g_point->trail_length)
		current->newest=0;

	X=fcos(-orign->orientation+PI_2);
	Y=fsin(-orign->orientation+PI_2);

	current->trail[newest].middle_v.X=X*(-0.01)+orign->position.X;
	current->trail[newest].middle_v.Y=Y*(-0.01)+orign->position.Y;

	current->trail[newest].left_v.X=-Y*0.5+current->trail[newest].middle_v.X;
	current->trail[newest].left_v.Y=X*0.5+current->trail[newest].middle_v.Y;

	current->trail[newest].right_v.X=Y*0.5+current->trail[newest].middle_v.X;
	current->trail[newest].right_v.Y=-X*0.5+current->trail[newest].middle_v.Y;

	current->trail[newest].intensity=orign->t_intensity*g_point->trail_opasity;
	}


void draw_trail(global *g_point, trail_header *tmp, player *orign, int count)
	{
	trail_header* current=malloc(sizeof(trail_header)+(sizeof(trail_element)*g_point->trail_length));

	memcpy(current,tmp,sizeof(trail_header)+(sizeof(trail_element)*g_point->trail_length));

	int newest=current->newest;
	int left=newest-1;
	int right=left;

	int drawer=1;

	float fade=1.0f/(float)g_point->trail_length;

	float red, green, blue, darknes;
	red=orign->red+0.1f;
	green=orign->green+0.1f;
	blue=orign->blue+0.1f;
	darknes=0.0f;

		glLoadIdentity();					// Reset The View
		glTranslatef(0,0,-22.0f+count*0.01);		// Move Left to current position And Into The Screen

  	glBegin(GL_QUADS);				// start drawing a polygon

while (drawer<g_point->trail_length && drawer<g_point->round_time) //indst en eller anden bremse, s der ikke bliver fejl i starten med rd og gul
	{

float intensity=current->trail[left+1].intensity*(1-drawer*fade);

	//left side
if (left!=g_point->trail_length-1)
	{
	glColor4f(red,green,blue, darknes);
	glVertex3f(current->trail[left+1].left_v.X,current->trail[left+1].left_v.Y, 0.002f);		// Bottom Left
	glColor4f(red,green,blue, intensity);
	glVertex3f(current->trail[left+1].middle_v.X,current->trail[left+1].middle_v.Y, 0.002f);		// Bottom Left
	}
else
	{
	intensity=current->trail[0].intensity*(1-(drawer)*fade);
	glColor4f(red,green,blue,darknes);
	glVertex3f(current->trail[0].left_v.X,current->trail[0].left_v.Y, 0.002f);		// Bottom Left
	glColor4f(red,green,blue,intensity);
	glVertex3f(current->trail[0].middle_v.X,current->trail[0].middle_v.Y, 0.002f);		// Bottom Left
	}

	intensity=current->trail[left].intensity*(1-(drawer-1)*fade);

if (left>=0)
	{
		glColor4f(red,green,blue,intensity);
		glVertex3f(current->trail[left].middle_v.X,current->trail[left].middle_v.Y, 0.002f);		// Bottom Right
 		glColor4f(red,green,blue, darknes);
		glVertex3f(current->trail[left].left_v.X,current->trail[left].left_v.Y, 0.002f);		// Bottom Right
	}

else
	{
	left=g_point->trail_length-1;

	intensity=current->trail[left].intensity*(1-(drawer-1)*fade);

		glColor4f(red,green,blue,intensity);
		glVertex3f(current->trail[left].middle_v.X,current->trail[left].middle_v.Y, 0.002f);		// Bottom Right
 		glColor4f(red,green,blue, darknes);
		glVertex3f(current->trail[left].left_v.X,current->trail[left].left_v.Y, 0.002f);		// Bottom Right
	}

//right side

	intensity=current->trail[right+1].intensity*(1-(drawer)*fade);

if (right!=g_point->trail_length-1)
	{
	glColor4f(red,green,blue,intensity);
	glVertex3f(current->trail[right+1].middle_v.X,current->trail[right+1].middle_v.Y, 0.002f);		// Bottom Left
	glColor4f(red,green,blue, darknes);
	glVertex3f(current->trail[right+1].right_v.X,current->trail[right+1].right_v.Y, 0.002f);		// Bottom Left
	}
else
	{
	intensity=current->trail[0].intensity*(1-(drawer)*fade);

	glColor4f(red,green,blue,intensity);
	glVertex3f(current->trail[0].middle_v.X,current->trail[0].middle_v.Y, 0.002f);		// Bottom Left
	glColor4f(red,green,blue,darknes);
	glVertex3f(current->trail[0].right_v.X,current->trail[0].right_v.Y, 0.002f);		// Bottom Left
	}

	intensity=current->trail[right].intensity*(1-(drawer-1)*fade);

if (right>=0)
	{
 		glColor4f(red,green,blue, darknes);
		glVertex3f(current->trail[right].right_v.X,current->trail[right].right_v.Y, 0.002f);		// Bottom Right
		glColor4f(red,green,blue,intensity);
		glVertex3f(current->trail[right].middle_v.X,current->trail[right].middle_v.Y, 0.002f);		// Bottom Right
	}

else
	{
	right=g_point->trail_length-1;

	intensity=current->trail[right].intensity*(1-(drawer)*fade);

 		glColor4f(red,green,blue, darknes);
		glVertex3f(current->trail[right].right_v.X,current->trail[right].right_v.Y, 0.002f);		// Bottom Right
		glColor4f(red,green,blue,intensity);
		glVertex3f(current->trail[right].middle_v.X,current->trail[right].middle_v.Y, 0.002f);		// Bottom Right
	}
	   left--;
	   right--;
	   drawer++;

 	}

free(current);

}

void update_trails (global *g_point)
{

int trail=0;

player *current=g_point->first_player;

while(trail<g_point->number_of_players)
	{
	if(t==0)
	update_trail(g_point, g_point->trails[trail], current);

	draw_trail(g_point, g_point->trails[trail], current, trail);

	trail++;

	current=current->next;
	}

	t++;

	if (t>2)
		t=0;

}
